<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      :okText="isNew ? 'Добавить' : 'Сохранить'"
      data-qa="formTransportGroupBP"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="form-group">
          <ob-input
            label="Наименование группы"
            v-model="formData.title"
            placeholder="Укажите наименование для группы"
            :disabled="!isNew"
            :required="true"
            @input="resetError"
            data-qa="inputTitleBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <div class="form-group__title">Способ перевозки</div>
          <ObControlGroup
            :items="groupItems"
            v-model="formData.transportationWay"
            theme="light"
            height="slim"
            :disabled="!isNew"
            @input="resetError"
            data-qa="controlGroupTransportationWayBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group service-field">
          <ObSelect
              ref="servicesSelect"
              label="Тип услуги"
              placeholder="Выберите тип услуги"
              v-model="formData.serviceTypeUuid"
              :items="services"
              :disabled="!isNew"
              @input="resetError"
              data-qa="selectServiceTypeUuidBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <ObSelect
              v-model="formData.services"
              label="Тип автотранспорта"
              :isTagbox="true"
              :isDropdown="true"
              :required="true"
              :disabled="!transportTypes.length || !formData.serviceTypeUuid"
              :withCheckbox="true"
              placeholder="Выберите один или несколько вариантов"
              :items="transportTypes"
              @input="resetError"
              data-qa="selectMultipleServicesBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import api from '@/api';
import { getTokenData } from '@/tokenData';
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import ObSelect from "common-components/src/obComponents/obSelect";
import ObControlGroup from "common-components/src/obComponents/obControlGroup";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { required } from "vuelidate/lib/validators";
import { transportationTypes } from "@/constants/basePrice.js";

const tokenData = { ...getTokenData() }

export default {
  name: "BasePriceTransportTypeGroupForm",
  components: {
    ObForm,
    ObInput,
    ObAlert,
    ObControlGroup,
    ObSelect,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  data () {
    return {
      error: '',
      isShowLoader: false,
      services: [],
      transportTypes: [],
      groupItems: transportationTypes,
    }
  },
  created() {
    this.$nextTick(() => {
      this.getServicesList();
    });
  },
  computed: {
    formModel() {
      return {
        uuid: {
          value: null,
        },
        title: {
          value: '',
          validator: {
            required
          }
        },
        serviceTypeUuid: {
          value: null,
          validator: {
            required
          }
        },
        services: {
          value: null,
          validator: {
            required
          }
        },
        transportationWay: {
          value: 'FTL',
          validator: {
            required
          }
        },
      }
    },
    isNew() {
      return !this.formData.uuid;
    },
  },
  watch: {
    'formData.transportationWay' () {
      this.transportTypes = [];
      if ( this.isNew ) {
        this.formData.services = [];
        this.formData.serviceTypeUuid = null;
      }
      this.getServicesList();
    },
    'formData.serviceTypeUuid' () {
      this.getTransportTypes();
    },
  },
  methods: {
    async onSubmitHandler() {
      let data = {...this.formData};
      if (this.isNew) {
        let params = {
          title: data.title,
          serviceTypeUuid: data.serviceTypeUuid,
          services: data.services,
          transportationWay: data.transportationWay,
        }
        this.isShowLoader = true;
        try {
          await api.base_prices_clustering.createTransportGroup(params, tokenData.user_uuid)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Группа успешно создана",
              });
              this.$emit("save", {formData: res});
            })
            .catch((err) => {
              if (err.error) {
                this.error = err.error_message;
              }
            })
            .finally(() => {
              this.isShowLoader = false;
            });
        } catch (e) {
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'Ошибка сохранения группы'});
          this.error = 'Ошибка сохранения группы';
        }
      } else {
        try {
          await api.base_prices_clustering.updateTransportGroupServices(data.uuid, data.services)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Список сохранен",
              });
              this.$emit("save", {formData: res});
            })
            .catch((err) => {
              if (err.error) {
                this.error = err.error_message;
              }
            })
            .finally(() => {
              this.isShowLoader = false;
            });

        } catch (e) {
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'Ошибка сохранения списка типов транспорта'});
          this.error = 'Ошибка сохранения';
        }
      }
    },
    async getServicesList() {
      if (this.formData.transportationWay) {
        try {
          const res = await api.orders.getTransport(
              this.formData.transportationWay
          );
          this.services = res;
        } catch (err) {
          console.error(err);
        }
      }
    },
    async getTransportTypes() {
      const params = {
        isActive: true,
        serviceTypeUuids: [ this.formData.serviceTypeUuid ]
      };
      try {
        const types = await api.services.getServicesAll(params);
        types.forEach(type => {
          type.title = type.resourceSubtypeTitle + " " + type.resourcePatternParameter;
        })
        this.transportTypes = types;
      } catch (err) {
        console.error(err);
      }
    },
    resetError() {
      this.error = '';
    },
  }
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }

}

.service-field{
  width: 410px;
}
</style>